
function SW_SlashCommand(msg)
	if msg == nil then return; end
	
	local _,_, c, v = string.find(msg, "([^ ]+) (.+)");
	if c == nil then
		c = string.gsub(msg, " ", "");
	end
	if c == "" then
		SW_PrintHelp();
		return;
	end
	
	local cmd = nil;
	for k,v in pairs(SW_SlashCommands) do
		if v["c"] == c then
			cmd = v;
			break;
		end
	end
	if cmd == nil then
		SW_printStr(SW_CONSOLE_NOCMD .. c);
		SW_printStr(SW_CONSOLE_HELP ..SW_RootSlashes[1].." "..SW_SlashCommands["help"]["c"]);
		return;
	end
	
	if cmd["aC"] > 0 then
		if v == nil or string.gsub(v, " ", "") == "" then
			SW_printStr(cmd["u"]);
			return;
		end
		cmd["f"](v);
	else
		cmd["f"]();
	end
end

function SW_ToggleConsole()
	local frame = getglobal("SW_FrameConsole")
	if(  frame:IsVisible() ) then
		frame:Hide();
	else
		frame:Show();
	end
end
function SW_ToggleBarFrame()
	local frame = getglobal("SW_BarFrame1")
	if(  frame:IsVisible() ) then
		frame:Hide();
	else
		frame:Show();
	end
end
function SW_ToggleGeneralSettings()
	local frame = getglobal("SW_GeneralSettings")
	if(  frame:IsVisible() ) then
		frame:Hide();
	else
		frame:Show();
	end
end
function SW_DumpVar(cmdString)
	local varName = string.gsub(cmdString, " ", "")
	local g = getfenv();
	
	if g[varName] == nil then
		SW_printStr(varName..SW_CONSOLE_NIL_TRAILER);
		return;
	else
		if type(g[varName]) == "table" then
			SW_DumpTable(g[varName]);
		else
			SW_printStr(g[varName]);
		end
	end
	
end
function SW_ResetInfo()
	SW_S_Details = {};
	SW_S_Healed = {};
	SW_S_SpellInfo = {};
	SW_S_ManaUsage = {};
	SW_S_LastManaSent = {0,0,0};
	SW_CombatTime = 0;
	SW_DPS_Dmg =0;
end

function SW_PostCheck(target)
	local id;
	if SW_Settings["SYNARP"] then
		return true;
	end
	if UnitInRaid("player") then
		if IsRaidLeader() or IsRaidOfficer() then
			return true;
		else
			if target == "RAID" then
				return false;
			else
				return true;
			end
		end
	--[[ hmm i think this is to restrictive
	elseif UnitInParty("player") then
		if IsPartyLeader() then
			return true;
		else
			if target == "PARTY" then
				return false;
			else
				return true;
			end
		end
	--]]
	else
		return true;
	end
end

function SW_ResetCheck()
	local id;
	
	if SW_Settings["SYNCLastChan"] == nil then
		StaticPopup_Show("SW_Reset");
		return;
	else
		-- are we still in this channel?
		id, _ = GetChannelName(SW_Settings["SYNCLastChan"]); 
		if id == 0 then
			StaticPopup_Show("SW_Reset");
			return;
		else
			--here we are in a active syncchan 
			if UnitInRaid("player") then
				if IsRaidLeader() or IsRaidOfficer() then
					StaticPopup_Show("SW_ResetSync");
				else
					StaticPopup_Show("SW_ResetFailInfo");
				end
			else
				if IsPartyLeader() then
					StaticPopup_Show("SW_ResetSync");
				else
					StaticPopup_Show("SW_ResetFailInfo");
				end
			end
		end
	end
end
function SW_RebuildFriendList()
	if  GetNumRaidMembers() > 0 then
		SW_Make_Friends("RAID");
	elseif GetNumPartyMembers() > 0 then
		SW_Make_Friends("GROUP");
	else
		SW_Make_Friends();
	end
end
function SW_ShowDetails(cmdString)
	local who = SW_S_Details[ cmdString ];
	local val ="";
	local vMax = "";
	if who == nil then
		SW_printStr(RED_FONT_COLOR_CODE..SW_INFO_PLAYER_NF..cmdString);
		return;
	end
	SW_printStr(LIGHTYELLOW_FONT_COLOR_CODE.."------ INFO "..cmdString.."-------", 1);
	for k,v in pairs(who) do
		if k == SW_PRINT_ITEM_RECIEVED then
			SW_printStr(LIGHTYELLOW_FONT_COLOR_CODE..k..FONT_COLOR_CODE_CLOSE..":  "..string.format(SW_PRINT_INFO_RECIEVED, v[1], v[2]), 1);			
		elseif k == SW_PRINT_ITEM_TYPE then
			-- ignore in this printout
		elseif k == SW_PRINT_ITEM_TOTAL_DONE then
			-- TODO ignored for now
		elseif k == "UTYPE" then
			--PC or NPC ignore
		elseif k == "CLASSE" then
		elseif k == SW_PRINT_ITEM_DEATHS then
			SW_printStr(LIGHTYELLOW_FONT_COLOR_CODE..k..FONT_COLOR_CODE_CLOSE..":  "..v);			
		else
			if v[1] > 0  and v[2] > 0 then
				val = v[1].." "..GREEN_FONT_COLOR_CODE..v[2]..FONT_COLOR_CODE_CLOSE;
				vMax = v[3];
			else
				if v[1] > 0 then
					val = v[1];
					vMax = v[3];
				else
					val = GREEN_FONT_COLOR_CODE..v[2]..FONT_COLOR_CODE_CLOSE;
					vMax = GREEN_FONT_COLOR_CODE..v[3]..FONT_COLOR_CODE_CLOSE;
				end
			end
			
			SW_printStr(LIGHTYELLOW_FONT_COLOR_CODE..k..FONT_COLOR_CODE_CLOSE..":  "..val..RED_FONT_COLOR_CODE.."  Max:"..FONT_COLOR_CODE_CLOSE..vMax, 1);
		end
	end
end
function SW_ShowHealed(cmdString)
	local who = SW_S_Healed[ cmdString ];
	if who == nil then
		SW_printStr(RED_FONT_COLOR_CODE..SW_INFO_PLAYER_NF.."("..SW_PRINT_ITEM_HEAL ..") "..cmdString);
		return;
	end
	SW_printStr(LIGHTYELLOW_FONT_COLOR_CODE.."---- INFO "..cmdString.." "..SW_PRINT_ITEM_HEAL..": ".."-----", 1);
	for k,v in pairs(who) do
		if v > 0 then
			SW_printStr(LIGHTYELLOW_FONT_COLOR_CODE..k..FONT_COLOR_CODE_CLOSE..":  "..GREEN_FONT_COLOR_CODE..v..FONT_COLOR_CODE_CLOSE, 1);
		end
	end
end
function SW_ShowHealedTarget(cmdString)
	SW_printStr(LIGHTYELLOW_FONT_COLOR_CODE.."---- INFO "..cmdString.." "..SW_PRINT_ITEM_HEAL.." "..SW_PRINT_ITEM_RECIEVED..": ".."-----", 1);
	for k,v in pairs(SW_S_Healed) do
		if v[cmdString] ~= nil then
			SW_printStr(LIGHTYELLOW_FONT_COLOR_CODE..k..FONT_COLOR_CODE_CLOSE..":  "..GREEN_FONT_COLOR_CODE..v[cmdString]..FONT_COLOR_CODE_CLOSE, 1);
		end
	end
end
function SW_ShowOverHeal()
	local personOverheals = {};
	local ohCount = {};
	local tmpRec;
	local oHealers = {};
	SW_printStr(LIGHTYELLOW_FONT_COLOR_CODE.."------------ OH INFO --------------- "..FONT_COLOR_CODE_CLOSE);
	for k,v in pairs(SW_S_Details) do
		tmpRec = v[SW_PRINT_ITEM_RECIEVED];
		if tmpRec[1] > 0 and tmpRec[2] > 0 then
			personOverheals[k] = (tmpRec[2] / (tmpRec[1] / 100)) - 100;
		end
	end
	for k,v in pairs (SW_S_Healed) do
		ohCount[k] = 0;
		for t, val in pairs(v) do
			
			tmpRec = personOverheals[t];
			if tmpRec ~= nil and tmpRec > 0  then
				--SW_printStr("    "..t.. " " ..tmpRec);
				ohCount[k] = ohCount[k] + (val * (tmpRec / 100));
			end
			
		end
		if SW_S_Details[k] ~= nil then
			tmpRec = SW_S_Details[k][SW_PRINT_ITEM_TOTAL_DONE][2];
			
			local tmpVal = ohCount[k] / (tmpRec / 100);
			table.insert(oHealers, {k, tmpRec, ohCount[k], tmpVal });
			--SW_printStr(k.." "..tmpVal);
		end
	end
	table.sort(oHealers, function(a,b)
				return a[3] > b[3];
			end);
	for _,v in ipairs(oHealers) do
		if v[4] < 100 and v[3] > 1 then
			SW_printStr(LIGHTYELLOW_FONT_COLOR_CODE..v[1]..":  "..FONT_COLOR_CODE_CLOSE..string.format("%d", v[3]).." ("..string.format("%.1f", v[4]).."%)");
		end
		if v[4] >= 100 and v[3] > 1 then
			SW_printStr(RED_FONT_COLOR_CODE..v[1]..": >100% ");
		end
	end
end
function SW_ShowSchool(cmdString)
	local who = SW_S_Details[ cmdString ];
	local vals = {};

	if who == nil then
		SW_printStr(RED_FONT_COLOR_CODE..SW_INFO_PLAYER_NF..cmdString);
		return;
	end
	SW_printStr(LIGHTYELLOW_FONT_COLOR_CODE.."---- INFO "..cmdString..": "..SW_PRINT_ITEM_DMG.."-----", 1);
	for k,v in pairs(who[SW_PRINT_ITEM_TYPE]) do
		if v[1] > 0 then
			table.insert(vals, {k,v[1],v[2]});			
		end
	end
	table.sort(vals, 
			function(a,b)
				return a[2] > b[2];
			end);
	for _,v in ipairs(vals) do
		SW_printStr(LIGHTYELLOW_FONT_COLOR_CODE..v[1]..FONT_COLOR_CODE_CLOSE..":  "..v[2]..RED_FONT_COLOR_CODE.."  Max:"..FONT_COLOR_CODE_CLOSE..v[3], 1);
	end	
	SW_printStr(LIGHTYELLOW_FONT_COLOR_CODE.."---- INFO "..cmdString..": "..SW_PRINT_ITEM_DMG.." "..SW_PRINT_ITEM_RECIEVED.."-----", 1);
	--[[
	for k,v in pairs(who[SW_PRINT_ITEM_TYPE]) do
		if v[4] > 0 then
			SW_printStr(LIGHTYELLOW_FONT_COLOR_CODE..k..FONT_COLOR_CODE_CLOSE..":  "..v[4]..RED_FONT_COLOR_CODE.."  Max:"..FONT_COLOR_CODE_CLOSE..v[5], 1);
		end
	end
	--]]
	vals = {};
	for k,v in pairs(who[SW_PRINT_ITEM_TYPE]) do
		if v[4] > 0 then
			table.insert(vals, {k,v[4],v[5]});			
		end
	end
	table.sort(vals, 
			function(a,b)
				return a[2] > b[2];
			end);
	for _,v in ipairs(vals) do
		SW_printStr(LIGHTYELLOW_FONT_COLOR_CODE..v[1]..FONT_COLOR_CODE_CLOSE..":  "..v[2]..RED_FONT_COLOR_CODE.."  Max:"..FONT_COLOR_CODE_CLOSE..v[3], 1);
	end	
end
function SW_ShowInfo(cmdString)
	local what = string.gsub(cmdString, " ", "")
	local vals = {};
	local onlyF = SW_Settings["INF_ShowOnlyFriends"];
	local tmpVal;
	
	if what == "dmg" then
		for k,v in pairs(SW_S_Details) do
			tmpVal = v[SW_PRINT_ITEM_TOTAL_DONE][1];
			if onlyF then
				if SW_Friends[k] or SW_Pets[k] then
					if tmpVal >0 then
						table.insert(vals, {k,tmpVal});
					end
				end
			else
				if tmpVal >0 then
					table.insert(vals, {k,tmpVal});
				end
			end
		end
	elseif what == "heal" then
		for k,v in pairs(SW_S_Details) do
			tmpVal = v[SW_PRINT_ITEM_TOTAL_DONE][2];
			if onlyF then
				if SW_Friends[k] or SW_Pets[k] then
					if tmpVal >0 then
						table.insert(vals, {k,tmpVal});
					end
				end
			else
				if tmpVal >0 then
					table.insert(vals, {k,tmpVal});
				end
			end
		end
	end
	table.sort(vals, 
			function(a,b)
				return a[2] > b[2];
			end);
			
	SW_printStr(LIGHTYELLOW_FONT_COLOR_CODE.."------ INFO "..what.."-------", 1);
	for _,v in ipairs(vals) do
		SW_printStr(LIGHTYELLOW_FONT_COLOR_CODE..v[1].."  "..v[2], 1);
	end
	
end
function SW_PrintHelp()
	local con = getglobal("SW_FrameConsole");
	
	if con ~= nil and con:IsVisible() then
		con = getglobal("SW_FrameConsole_Text1_MsgFrame");
	else
		con = DEFAULT_CHAT_FRAME;
	end
	if con ~= nil then
		for k,v in pairs(SW_SlashCommands) do	
			if v["c"] ~= nil then
				if v["si"] ==nil then
					con:AddMessage("|cc0c0ff00"..v["c"]..":");
				else
					con:AddMessage("|cc0c0ff00"..v["c"]..":"..NORMAL_FONT_COLOR_CODE.."  "..v["si"]);
				end
				if v["u"] ~= nil then
					con:AddMessage(NORMAL_FONT_COLOR_CODE.."     "..v["u"]);
				end
			end
		end
	end
end

function SW_KickPlayer(who)
	if UnitInRaid("player") and not (IsRaidLeader() or IsRaidOfficer()) then
		return;
	end
	SW_SendSyncKick(who);
	
end

function SW_VersionCheck()
	SW_SyncSendRSV();
	local swc = getglobal("SW_FrameConsole");
	if not swc:IsVisible() then
		swc:Show();
	end
end
function SW_GetSkillUsage(cmdString)
	SW_SyncSendRSU(cmdString);
	local swc = getglobal("SW_FrameConsole");
	if not swc:IsVisible() then
		swc:Show();
	end
end